#include <Servo.h>
// #define DEBUG 1

const int servoMin = 5; // min value of the servo movement range
const int servoMax = 165; // max value of the servo movement range
const int gameDashMin = 0;
const int gameDashMax = 255;
const int minPowerOn = 20; // When the GameDash value exceeds this limit, the relais powers the fan control box
const int servoPin = 2; // signal pin of the servo
const int relaisPin = 3; // signal pin of the relais

int servoPos;
int speedGameDash;
int bufferArray[4];

Servo potControlServo;

void setup()
{  
  Serial.begin(9600);
  pinMode(relaisPin, OUTPUT);
  servoPos = 40;// servoMin;
  speedGameDash = 0;
  
  potControlServo.attach(servoPin);
  potControlServo.write(servoMin);
  digitalWrite(relaisPin, HIGH);
  MoveServo();
}

void loop()
{
  ReadData();
  MoveServo();
}

void ReadData()
{
  if (Serial.available() == 4) { //if 4 bits are available in the Serial buffer...

    int i;
    for (i=0; i<4; i=i+1) { // read and label each byte.
      bufferArray[i] = Serial.read();
    } 
    if (bufferArray[0]  == 'S') {
      speedGameDash = ((bufferArray[1]-48)*100) + ((bufferArray[2]-48)*10) + ((bufferArray[3]-48)*1); // Take values 1-3.
      if (speedGameDash > 255) {
        speedGameDash = 255;
      }
#ifdef DEBUG 
      Serial.print("You have set the Speed to a Value of ");  
      Serial.println(speedGameDash);
#endif
    }
  }
}

void MoveServo()
{
  int oldPosition = servoPos;
  servoPos = map(speedGameDash, gameDashMin , gameDashMax , servoMin , servoMax);
  if (oldPosition != servoPos){
#ifdef DEBUG
    Serial.print("Servo position set to ");
    Serial.println(servoPos);
#endif
    potControlServo.write(servoPos);

    if (speedGameDash < minPowerOn) {
      digitalWrite(relaisPin, HIGH);
    }
    else {
      digitalWrite(relaisPin, LOW); 
    }
  }
}
